/*
 * Please don't change this unless you make changes to the source, and
 * in that case, don't just ++ the number ;)
 */
#define VERSION "1.46"

/*
 * If you are running this as a mud utility, you can use the player.o files
 * instead of the etc/passwd file
 * undef this to use the passwd file.
 * DO NOT DEFINE THIS WITHOUT LOOKING AT THE FUNCTIONS: get_access_type(),
 * get_wizard_file() AND get_home_dir() IN "login.c"
 */
#undef  DOT_O_FILES

/*
 * define this only if you want to limit the number of users allowed on
 * the WizPort.  Otherwise undef it.
 * (Known bug: if there are MAX_USERS-1 connections, then wizport
 * will accept as many connections that come in until someone finally
 * logs in with their password -- in other words, MAX_USERS is checked
 * at execution of wizshell, but is not incremented for all of them until
 * the user actually completes login.
 * You might also wish to take a look at a similar feature in tcpserv
 */
/* #define MAX_USERS 2 */
#undef MAX_USERS

/*
 * MAX_WTMP_SIZE
 * The file etc/wtmp grows without bounds.  If this is defined, the
 * wtmp size will be checked every login, and if it exceeds this amount (k)
 * then it will be removed
 */
#define MAX_WTMP_SIZE 15

/*
 * MESG_DEFAULT
 * This is the default chat setting that a user will get upon logging in
 * 1 is on
 */
#define MESG_DEFAULT 1

/*
 * PATHS
 * These are the paths of files and directories inside of the ROOT_DIR
 * and WSH_DIR.  You shouldn't need to change these.
 */
#define BIN_DIR     WSH_DIR"/bin"
#define ETC_DIR     WSH_DIR"/etc"
#define PASSWD_FILE     ETC_DIR"/passwd"
#define WRITE_ACC_FILE  ETC_DIR"/write_access"
#define READ_ACC_FILE   ETC_DIR"/read_access"
#define EXCEPTIONS_FILE ETC_DIR"/exceptions"
#define UTMP_FILE       ETC_DIR"/utmp"
#define WTMP_FILE       ETC_DIR"/wtmp"
#define HOME_DIR        ROOT_DIR"/players"
#define WSH_FNAME       BIN_DIR"/wsh"

/*
 * Things you might want to change:
 * These are just parameters you might want to tweak a little
 */
#define HIST_SIZE 10  /* Starting size of history command */
#define MAX_ARGS 30   /* Maximum allowed arguments on command line */
#define ARG_SIZE 100  /* Maximum size of each argument */

#define ENCRYPT           /* define for using encryption */
#define LOGIN_ATTEMPTS 3  /* three failed attempts before disconnect */
#define MAX_FIELD 150     /* max login string size */

#define MAX_BUF 1000   /* max line size for command line */
#define MAX_PATH 700   /* max path size */

/* For the memory wrapper (see Makefile) */
#ifdef MEMWRAP
#define MALLOC(x) myalloc((int) x)
#define CALLOC(x,y) myalloc((int) (x)*(y))
#define FREE(x) myfree((char *) x)
char *myalloc(int);
int myfree(char *);
#else
#define MALLOC(x) malloc(x)
#define CALLOC(x,y) calloc(x,y)
#define FREE(x) free(x)
#endif


/* undef this if you want the access lookup to be fooled by links (less secure),
 * or if your system doesn't have links.
 * I haven't thoroughly tested the mk_path code with this off.
 */
#define RESOLVE_LINKS

/*
 * Things you probably don't want to change
 * These are the super-wizshell users serious configuration area.
 */

/*
 * Resolve paths method:  ONLY DEFINE ONE OF THESE THREE!
 * This is the method used to build the path.  Currently only
 * FROM_ROOT is coded in, this will be explained in a later
 * version of wsh when all of them work
 */
#define FROM_ROOT
/*
#define FROM_WD
#define HYBRID
*/

